/**********************************************************************
 * Copyright (C) 20014-2015 by Vidisolve (Pty) Ltd.                   *
 * All Rights Reserved.                                               *
 *                                                                    *
 *  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY    *
 *   KIND, either express or implied.                                 *
 *                                                                    *
 *  Contributors:                                                     *
 *                                                                    *
 **********************************************************************/
/*------------------------------------------------------------------------
    File        : pLogin.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Tue Jun 09 20:44:21 CAT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

BLOCK-LEVEL ON ERROR UNDO, THROW.

/* ***************************  Main Block  *************************** */
DEFINE INPUT  PARAMETER pLoginID   AS CHARACTER NO-UNDO.
DEFINE INPUT  PARAMETER pPasswd    AS CHARACTER NO-UNDO.
/* Support for legacy routines - the following three parameters should be dropped */
DEFINE OUTPUT PARAMETER pSuccess   AS LOGICAL   NO-UNDO.
DEFINE OUTPUT PARAMETER pRoles     AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER pRolesDesc AS CHARACTER NO-UNDO.

DEFINE VARIABLE hCP AS HANDLE NO-UNDO.

SECURITY-POLICY:LOAD-DOMAINS("security").

CREATE CLIENT-PRINCIPAL hCP.

hCP:INITIALIZE (pLoginID,GUID,?,pPasswd).


SECURITY-POLICY:SET-CLIENT (hCP) .

IF SESSION:REMOTE
THEN SESSION:CURRENT-RESPONSE-INFO:SetClientPrincipal(hCP).


/* Legacy support */
ASSIGN
    pSuccess   = hCP:LOGIN-STATE = "LOGIN":U OR hCP:LOGIN-STATE = "SSO":U
    pRoles     = hCP:ROLES
    pRolesDesc = hCP:GET-PROPERTY("RoleNames")
    .